unit TabletUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Tablet, WintabConsts, Buttons, StdCtrls, ComCtrls, ExtCtrls;

type
  TPacket = record
    Cursor: Integer;
    Buttons: Integer;
    Coords: TPoint;
    Pressure: Integer;
  end;

  TMainForm = class(TForm)
    Tablet1: TTablet;
    StatusBar1: TStatusBar;
    CheckBox1: TCheckBox;
    ProgressBar1: TProgressBar;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    ComboBox1: TComboBox;
    Panel1: TPanel;
    procedure Tablet1Packet(Sender: TObject; PacketNumber, ContextHandle: Integer; pPacket: Pointer);
    procedure Tablet1CursorChanged(Sender: TObject; PacketNumber, ContextHandle: Integer; pPacket: Pointer);
    procedure Tablet1Proximity(Sender: TObject; ContextHandle: Integer; Entering: Boolean);
    procedure CheckBox1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.Tablet1Packet(Sender: TObject; PacketNumber, ContextHandle: Integer;
  pPacket: Pointer);
begin
  with TPacket(pPacket^), StatusBar1 do
  begin
    ProgressBar1.Position := Pressure;
    Panels[0].Text := IntToStr(Cursor);
    Panels[1].Text := IntToStr(Coords.x);
    Panels[2].Text := IntToStr(Coords.y);
    Panels[3].Text := IntToStr(Pressure);
    Panels[4].Text := IntToStr(Buttons);
  end;
end;

procedure TMainForm.Tablet1CursorChanged(Sender: TObject; PacketNumber,
  ContextHandle: Integer; pPacket: Pointer);
begin
  case TPacket(pPacket^).Cursor of
    1: Panel1.Color := $004914c1;
    2: Panel1.Color := $00c14914;
    3: Panel1.Color := $0014c149;
  end;
end;

procedure TMainForm.Tablet1Proximity(Sender: TObject; ContextHandle: Integer;
  Entering: Boolean);
begin
  if Entering then StatusBar1.Panels[5].Text := 'Down' else
  begin
    StatusBar1.Panels[5].Text := 'Up';
    Panel1.Color := clBlack;
  end;
end;

procedure TMainForm.CheckBox1Click(Sender: TObject);
begin
  with Tablet1, Tablet1.Context do
  if Present then
  begin
  	Options := Options or CXO_SYSTEM or CXO_MESSAGES or CXO_CSRMESSAGES;
  	PktData := PK_CURSOR or PK_BUTTONS or PK_X or PK_Y or PK_NORMAL_PRESSURE;
    MsgBase := WT_DEFBASE;
    Enabled := CheckBox1.Checked;
  end;
end;

procedure TMainForm.ComboBox1Change(Sender: TObject);
var
  TabletX, TabletY: TAxis;
begin
  with Tablet1, Tablet1.Context do
  if Present then
  begin
    WTInfo(WTI_DEVICES, DVC_X, @TabletX);
    WTInfo(WTI_DEVICES, DVC_Y, @TabletY);
    case TComboBox(Sender).ItemIndex of
      0:
      begin
        { output the data in screen coords }
      	OutExtX := TabletX.Max;
      	OutExtY := -TabletY.Max;
      end;
      1:
      begin
      	OutExtX := GetSystemMetrics(SM_CXSCREEN);
      	OutExtY := -GetSystemMetrics(SM_CYSCREEN);
      end;
    end;
    if not SetContext then ShowMessage('Failed to set context');
  end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
  CharArray: TString;
  MaxPressure: TAxis;
begin
  with Tablet1 do
  if Present then
  begin
    Initialize;
    PacketSize := SizeOf(TPacket);
    Label1.Caption := DeviceName;
  	WTInfo(WTI_DEVICES, DVC_NPRESSURE, @MaxPressure);
    ProgressBar1.Max := MaxPressure.Max;
    WTInfo(WTI_INTERFACE, IFC_WINTABID, @CharArray);
    Label2.Caption := CharArray;
    ComboBox1.ItemIndex := 0;
  end
  else ShowMessage('Tablet not found');
end;

end.
